package cc.smtweb.system.bpm.web.engine;

import cc.smtweb.framework.core.SwException;
import cc.smtweb.framework.core.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.design.form.ModelFormHelper;
import cc.smtweb.system.bpm.web.design.form.define.PageInfo;

/**
 * Created by Akmm at 2022/4/21 17:53
 */
public abstract class AbstractDynPageHandler extends AbstractHandler {
    //页面定义id
    protected long pageId;
    protected PageInfo pageInfo;

    @Override
    public void init(SwMap params, UserSession us) {
        super.init(params, us);
        pageId = params.readLong("pageId");

        pageInfo = ModelFormHelper.parsePageInfo(pageId);
        if (pageInfo == null) throw new SwException("没有找到页面定义数据！");
        ModelFormHelper.resetDataset(pageInfo);
    }
}
