package cc.smtweb.system.bpm.web.engine;

import cc.smtweb.framework.core.R;
import cc.smtweb.framework.core.SwMap;
import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.db.vo.ModelCatalog;
import cc.smtweb.framework.core.mvc.service.*;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.design.table.ModelCatalogTreeHandler;

/**
 * Created by Akmm at 2022/4/21 17:43
 * 动态页面引擎
 */
@SwService
public class DynPageService extends AbstractCompService {
    public final static String TYPE_ADD = "add";
    public final static String TYPE_LOAD_ONE = "loadOne";
    public final static String TYPE_DEL_ONE = "delOne";

    @Override
    protected IHandler createHandler(String type) {
        switch (type) {
            case TYPE_ADD:
                return new DynPageAddHandler();
            case TYPE_LOAD_ONE:
                return new DynPageLoadOneHandler();
            case TYPE_SAVE:
                return new DynPageSaveHandler();
            case TYPE_DEL:
                return new DefaultDelHandler<>(ModelCatalog.ENTITY_NAME);
            case TYPE_DEL_ONE:
                return new DefaultDelHandler<>(ModelCatalog.ENTITY_NAME);
            case TYPE_LIST:
                return new DefaultListHandler<>(ModelCatalog.ENTITY_NAME);
            case TYPE_TREE:
                return new ModelCatalogTreeHandler();
        }
        return null;
    }

    //新增
    public R add(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_ADD);
    }

    //保存指定数据集
    public R saveOne(@SwBody SwMap params, UserSession us) {
        try {
            DynPageSaveHandler handler = (DynPageSaveHandler) getHandler(params, us, TYPE_SAVE);
            return handler.saveOne();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    //列表总记录数及合计栏
    public R total(@SwBody SwMap params, UserSession us) {
        try {
            DynPageLoadOneHandler handler = (DynPageLoadOneHandler) getHandler(params, us, TYPE_LOAD_ONE);
            return handler.getTotal();
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }
}
