package cc.smtweb.system.bpm.test;

import cc.smtweb.system.bpm.util.CodeGenUtil;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;

/**
 * Created by Akmm at 2022/3/1 9:41
 * 生成bean
 */
public class BuildJavaBean {
    @Test
    public void buildBean() {
        String str = "`mf_id` bigint(20) NOT NULL,\n" +
                "  `mf_prj_id` bigint(20) NOT NULL DEFAULT '-1',\n" +
                "  `mf_mc_id` bigint(20) DEFAULT NULL COMMENT '-1',\n" +
                "  `mf_name` varchar(32) COLLATE utf8_unicode_ci DEFAULT '名称',\n" +
                "  `mf_title` varchar(200) COLLATE utf8_unicode_ci NOT NULL COMMENT '标题',\n" +
                "  `mf_type` int(4) DEFAULT '0',\n" +
                "  `mf_service` varchar(100) COLLATE utf8_unicode_ci NOT NULL COMMENT '服务名',\n" +
                "  `mf_content` text COLLATE utf8_unicode_ci COMMENT '详细信息',\n" +
                "  `mf_create_uid` bigint(20) DEFAULT NULL,\n" +
                "  `mf_update_uid` bigint(20) DEFAULT NULL,\n" +
                "  `mf_create_at` bigint(20) NOT NULL DEFAULT '0',\n" +
                "  `mf_update_at` bigint(20) NOT NULL DEFAULT '0',\n" +
                "  `mf_remark` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT '备注',\n";
        String[] ss = str.split("\n");
        for (String s: ss) {
            String[] s0 = s.trim().split(" ");
            if (StringUtils.isEmpty(s0[0])) continue;
            String tn = s0[0].substring(1, s0[0].indexOf("`", 2));
            String tnu = CodeGenUtil.underlineToUpperHump(tn.substring(tn.indexOf("_") + 1));
            String tnn = CodeGenUtil.underlineToHump(tn);

            String tt = s0[1];
            String ttj;
            if (tt.contains("(")) tt = tt.substring(0, tt.indexOf("("));
            switch (tt) {
                case "bigint":
                    tt = "long";
                    ttj = "Long";
                    break;
                case "tinyint":
                    case "int":
                    tt = "int";
                    ttj = "Int";
                    break;
                default:
                    tt = "String";
                    ttj = "Str";
                    break;
            }
            System.out.println("public " + tt + " get" + tnu + "(){\n" +
                    "return get" + ttj + "(\"" + tn + "\");\n" +
                    "}\n" +
                    "" +
                    "public void set" + tnu + "(" + tt + " " + tnn + "){\n" +
                    "put(\"" + tn + "\", " + tnn + ");\n" +
                    "}\n");
        }
    }
}
